import type { GetDocumentTypeNamesGen } from '@contentlayer/core'
import type * as SourceFiles from '@contentlayer/source-files'
import { defineDocumentType } from '@contentlayer/source-files'

// TODO change back to function expression once fixed https://github.com/microsoft/TypeScript/issues/37151#issuecomment-756232934
export function addComputedFields<DefName extends GetDocumentTypeNamesGen>({
  documentTypes,
  documentTypeName,
  computedFields,
}: {
  documentTypes: SourceFiles.DocumentType[]
  documentTypeName: DefName
  computedFields: SourceFiles.ComputedFields<DefName>
}): void {
  const documentType = documentTypes.find((_) => _.def().name === documentTypeName)

  if (!documentType) {
    throw new Error(`Document type "${documentTypeName}" not found`)
  }

  const previousDef = documentType.def()
  documentType.def = defineDocumentType(() => ({ ...previousDef, computedFields })).def
}
